Subject: bug#64270: 30.0.50; Font update for no toolkit menu

From: Manuel Giraud <[email-masked]>
Date: Tue, 27 Jun 2023 09:04:51 +0200

Eli Zaretskii <[email-masked]> writes:

>> Date: Sat, 24 Jun 2023 19:00:04 +0200
>> From:  Manuel Giraud via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <[email-masked]>
>> 
>> I'd like to be able to update the menu font (for the no toolkit build)
>> at runtime.  For this, my idea was to pass the font (from say the menu
>> face) to the XMenuCreate call in x_menu_show.
>
> Doesn' paneFont X resource already allow that?

Yes it does and I'm using it.  What I'm trying to achieve here is to be
able to change those menu face dynamically: if a user changes the main
frame font with 'set-frame-font', the menu font is also changed.

>> I thought that the font's XLFD string would be a good candidate to pass
>> this information since it should be understood by XLoadQueryFont.  But
>> unfortunately, the XLFD returned by font_unparse_xlfd are not.
>> 
>> For instance, XLoadQueryFont can understand
>> "-misc-fixed-medium-r-normal-*-22-*-*-*-*-*-*-*" but not
>> "-misc-fixed-regular-r-normal-*-22-*-*-*-*-*-*-*".  Do you think I need
>> a function to « normalize » the XLFD returned by font_unparse_xlfd?  Or
>> maybe I'm missing something?
>> 
>> FTR, here is a patch of what I have started:
>
> Did you try a font name instead?

No I did not try that.
-- 
Manuel Giraud